"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var parse_1 = require('../utils/parse');
var CountByPipe = (function () {
    function CountByPipe() {
        this.$parse = parse_1.Parse();
    }
    CountByPipe.prototype.transform = function (collection, predicate) {
        var result = {}, getter = this.$parse(predicate);
        if (!utils_1.isArray(collection)) {
            collection = utils_1.toArray(collection);
        }
        collection.forEach(function (elm) {
            var prop = getter(elm);
            if (!(prop in result))
                result[prop] = 0;
            result[prop]++;
        });
        return result;
    };
    CountByPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'countBy'
                },] },
    ];
    /** @nocollapse */
    CountByPipe.ctorParameters = function () { return []; };
    return CountByPipe;
}());
exports.CountByPipe = CountByPipe;
//# sourceMappingURL=count-by.pipe.js.map