"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var parse_1 = require('../utils/parse');
var GroupByPipe = (function () {
    function GroupByPipe() {
        this.$parse = parse_1.Parse();
    }
    GroupByPipe.prototype.transform = function (collection, prop) {
        if (!utils_1.isArray(collection)) {
            collection = utils_1.toArray(collection);
        }
        var result = {}, getter = this.$parse(prop);
        collection.forEach(function (elm) {
            var prop = getter(elm);
            if (utils_1.isUndefined(result[prop])) {
                result[prop] = [];
            }
            result[prop].push(elm);
        });
        return result;
    };
    GroupByPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'groupBy'
                },] },
    ];
    /** @nocollapse */
    GroupByPipe.ctorParameters = function () { return []; };
    return GroupByPipe;
}());
exports.GroupByPipe = GroupByPipe;
//# sourceMappingURL=group-by.pipe.js.map