"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var parse_1 = require('../utils/parse');
var SearchFieldPipe = (function () {
    function SearchFieldPipe() {
        this.$parse = parse_1.Parse();
    }
    SearchFieldPipe.prototype.transform = function (collection) {
        var _this = this;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (!utils_1.isArray(collection) || !args.length) {
            return collection;
        }
        return collection.map(function (member) {
            var field = args.map(function (field) { return _this.$parse(field)(member); }).join(' ');
            member.searchField = field;
            return member;
        });
    };
    SearchFieldPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'searchField'
                },] },
    ];
    /** @nocollapse */
    SearchFieldPipe.ctorParameters = function () { return []; };
    return SearchFieldPipe;
}());
exports.SearchFieldPipe = SearchFieldPipe;
//# sourceMappingURL=search-field.pipe.js.map