"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var parse_1 = require('../utils/parse');
var UniqPipe = (function () {
    function UniqPipe() {
        this.$parse = parse_1.Parse();
    }
    UniqPipe.prototype.transform = function (collection, predicate) {
        if (!utils_1.isArray(collection)) {
            collection = utils_1.toArray(collection);
        }
        if (utils_1.isUndefined(predicate)) {
            return collection.filter(function (e, i, self) { return self.indexOf(e) == i; });
        }
        var getter = this.$parse(predicate), uniqueItems = [];
        return collection.filter(function (e) {
            var v = getter(e);
            if (!utils_1.isUndefined(v) && uniqueItems.some(function (ue) { return ue === v; })) {
                return false;
            }
            uniqueItems.push(v);
            return true;
        });
    };
    UniqPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'uniq'
                },] },
    ];
    /** @nocollapse */
    UniqPipe.ctorParameters = function () { return []; };
    return UniqPipe;
}());
exports.UniqPipe = UniqPipe;
//# sourceMappingURL=uniq.pipe.js.map