"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var parse_1 = require('../utils/parse');
var XORPipe = (function () {
    function XORPipe() {
        this.$parse = parse_1.Parse();
    }
    XORPipe.prototype.transform = function (col1, col2, predicate) {
        var _this = this;
        col1 = !utils_1.isArray(col1) ? utils_1.toArray(col1) : col1;
        col2 = !utils_1.isArray(col2) ? utils_1.toArray(col2) : col2;
        if (!utils_1.isArray(col1) || !utils_1.isArray(col2)) {
            return col1;
        }
        return col1.concat(col2)
            .filter(function (elm) {
            return !(_this.some(elm, col1, predicate) && _this.some(elm, col2, predicate));
        });
    };
    // TODO: add equlity check using "equals()" instead of ===
    XORPipe.prototype.some = function (el, col, predicate) {
        var getter = this.$parse(predicate);
        return col.some(function (dElm) {
            if (utils_1.isUndefined(predicate)) {
                return dElm === el;
            }
            return getter(dElm) === getter(el);
        });
    };
    XORPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'xor'
                },] },
    ];
    /** @nocollapse */
    XORPipe.ctorParameters = function () { return []; };
    return XORPipe;
}());
exports.XORPipe = XORPipe;
//# sourceMappingURL=xor.pipe.js.map