"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var ByteFmtPipe = (function () {
    function ByteFmtPipe() {
        var _this = this;
        this.compared = [{ str: 'B', val: 1024 }];
        ['KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'].forEach(function (el, i) {
            _this.compared.push({ str: el, val: _this.compared[i].val * 1024 });
        });
    }
    ByteFmtPipe.prototype.transform = function (bytes, decimal) {
        if (utils_1.isNumber(decimal) && isFinite(decimal) && decimal % 1 === 0 && decimal >= 0 &&
            utils_1.isNumber(bytes) && isFinite(bytes)) {
            var i = 0;
            while (i < this.compared.length - 1 && bytes >= this.compared[i].val)
                i++;
            bytes /= i > 0 ? this.compared[i - 1].val : 1;
            return utils_1.convertToDecimal(bytes, decimal) + ' ' + this.compared[i].str;
        }
        return 'NaN';
    };
    ByteFmtPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'byteFmt'
                },] },
    ];
    /** @nocollapse */
    ByteFmtPipe.ctorParameters = function () { return []; };
    return ByteFmtPipe;
}());
exports.ByteFmtPipe = ByteFmtPipe;
//# sourceMappingURL=byte-fmt.pipe.js.map