"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var DegreesPipe = (function () {
    function DegreesPipe() {
    }
    DegreesPipe.prototype.transform = function (radians, decimal) {
        // if decimal is not an integer greater than -1, we cannot do. quit with error "NaN"
        // if degrees is not a real number, we cannot do also. quit with error "NaN"
        if (utils_1.isNumber(decimal) && isFinite(decimal) && decimal % 1 === 0 && decimal >= 0 &&
            utils_1.isNumber(radians) && isFinite(radians)) {
            var degrees = (radians * 180) / Math.PI;
            return Math.round(degrees * Math.pow(10, decimal)) / (Math.pow(10, decimal));
        }
        else {
            return NaN;
        }
    };
    DegreesPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'degrees'
                },] },
    ];
    /** @nocollapse */
    DegreesPipe.ctorParameters = function () { return []; };
    return DegreesPipe;
}());
exports.DegreesPipe = DegreesPipe;
//# sourceMappingURL=degrees.pipe.js.map