"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var parse_1 = require('../utils/parse');
var MinPipe = (function () {
    function MinPipe() {
        this.$parse = parse_1.Parse();
    }
    MinPipe.prototype.transform = function (input, predicate) {
        return utils_1.isUndefined(predicate)
            ? Math.min.apply(Math, input)
            : input[this.index(input, this.$parse(predicate))];
    };
    MinPipe.prototype.index = function (input, fn) {
        var mappedArray = input.map(function (elm) { return fn(elm) || Infinity; });
        return mappedArray.indexOf(Math.min.apply(Math, mappedArray));
    };
    MinPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'min'
                },] },
    ];
    /** @nocollapse */
    MinPipe.ctorParameters = function () { return []; };
    return MinPipe;
}());
exports.MinPipe = MinPipe;
//# sourceMappingURL=min.pipe.js.map