"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var ShortFmtPipe = (function () {
    function ShortFmtPipe() {
    }
    ShortFmtPipe.prototype.transform = function (number, decimal) {
        if (utils_1.isNumber(decimal) && isFinite(decimal) && decimal % 1 === 0 && decimal >= 0 &&
            utils_1.isNumber(number) && isFinite(number)) {
            if (number < 1e3) {
                return '' + number; // Coerce to string
            }
            else if (number < 1e6) {
                return utils_1.convertToDecimal((number / 1e3), decimal) + ' K';
            }
            else if (number < 1e9) {
                return utils_1.convertToDecimal((number / 1e6), decimal) + ' M';
            }
            else {
                return utils_1.convertToDecimal((number / 1e9), decimal) + ' B';
            }
        }
        return 'NaN';
    };
    ShortFmtPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'shortFmt'
                },] },
    ];
    /** @nocollapse */
    ShortFmtPipe.ctorParameters = function () { return []; };
    return ShortFmtPipe;
}());
exports.ShortFmtPipe = ShortFmtPipe;
//# sourceMappingURL=short-fmt.pipe.js.map