"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var parse_1 = require('../utils/parse');
var FuzzyByPipe = (function () {
    function FuzzyByPipe() {
        this.$parse = parse_1.Parse();
    }
    FuzzyByPipe.prototype.transform = function (collection, property, search, csensitive) {
        if (csensitive === void 0) { csensitive = false; }
        if (!utils_1.isArray(collection)) {
            collection = utils_1.toArray(collection);
        }
        if (!utils_1.isArray(collection) || utils_1.isUndefined(search)) {
            return collection;
        }
        var getter = this.$parse(property);
        return collection.filter(function (elm) {
            var prop = getter(elm);
            if (!utils_1.isString(prop)) {
                return false;
            }
            if (!csensitive) {
                prop = prop.toLowerCase();
                search = search.toLowerCase();
            }
            return utils_1.hasApproxPattern(prop, search) !== false;
        });
    };
    FuzzyByPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'fuzzyBy'
                },] },
    ];
    /** @nocollapse */
    FuzzyByPipe.ctorParameters = function () { return []; };
    return FuzzyByPipe;
}());
exports.FuzzyByPipe = FuzzyByPipe;
//# sourceMappingURL=fuzzy-by.pipe.js.map