"use strict";
var core_1 = require('@angular/core');
var utils_1 = require('../utils/utils');
var FuzzyPipe = (function () {
    function FuzzyPipe() {
    }
    FuzzyPipe.prototype.transform = function (collection, search, csensitive) {
        var _this = this;
        if (csensitive === void 0) { csensitive = false; }
        if (!utils_1.isArray(collection)) {
            collection = utils_1.toArray(collection);
        }
        if (!utils_1.isArray(collection) || utils_1.isUndefined(search)) {
            return collection;
        }
        if (!csensitive) {
            search = search.toLowerCase();
        }
        return collection.filter(function (elm) {
            if (utils_1.isString(elm)) {
                if (!csensitive) {
                    elm = elm.toLowerCase();
                }
                return utils_1.hasApproxPattern(elm, search);
            }
            return utils_1.isObject(elm) ? _this.hasApproximateKey(elm, search, csensitive) : false;
        });
    };
    FuzzyPipe.prototype.hasApproximateKey = function (object, search, csensitive) {
        if (csensitive === void 0) { csensitive = false; }
        return Object.keys(object).some(function (elm) {
            var prop = object[elm];
            if (!utils_1.isString(prop)) {
                return false;
            }
            if (!csensitive) {
                prop = prop.toLowerCase();
            }
            return utils_1.hasApproxPattern(prop, search);
        });
    };
    FuzzyPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'fuzzy'
                },] },
    ];
    /** @nocollapse */
    FuzzyPipe.ctorParameters = function () { return []; };
    return FuzzyPipe;
}());
exports.FuzzyPipe = FuzzyPipe;
//# sourceMappingURL=fuzzy.pipe.js.map